//.\lcc -target=xr18CX "-Wa -D STACKLOC=0xEEEE" "-Wa -D NOFILLBSS=1 " "-Wa -D DATALOC=0xC000" "-Wa -D CPUSPEED=4000000" Terminal.c -o Terminal.hex "-Wf -volatile -cpu1805" "-DSCC=1" "-DDEBUG=0"
//set "-DSCC=1" to "-DSCC=0" to set it to bitbang Serial
//DATALOC moved from 0x8000 to 0xC000 to have 16K of ram free for bootloading
//stack went from 0xFFFF to EEEE to allow BIOS (reserved memory) bytes
//we have as such 12 014Bytes of free memory
#include <nstdlib.h>
#include "olduino.h"
#include <rand.h>




//#include <errno.h>
//#include <stdint.h>
void sccDEFAULT();
#include "SPI.h"
#define NULL 0x00
//#include <dumper.c>

#include <1806.h>
#include <EF.h>
#ifndef ULONG_MAX
#define	ULONG_MAX	((unsigned long)(~0L))		
#endif

#define ERANGE ((unsigned long)(~0L))

#if(SCC == 0)
#error you are on bitbanged mode
#define putc(x) putcser(x)
unsigned char getcser();
#define getc() getcser()
void putcser(unsigned char);

#endif

#if(SCC == 1)
#error legacy API in use, use -DSCC=2 for the new API
#define putc(x) sccOUT(x);
#define getc() sccIN()
void sccOUT(char);
char sccIN();
void sccOUT2(char x);
char sccIN2();
#endif

#if(SCC == 2)

#include "scc.h"
#define putc(x) sccOUT(x);
#define getc() sccIN()
void sccOUT(char);
char sccIN();

#endif


#if(DEBUG == 1)
#error DEBUG MODE IS ON
#endif
//#define EOT 4
//#define REGADDR (unsigned int *)0xFF00 //where the registers are stored on reset
//#define CODEADDR (unsigned char *)0x8000 //address where code is loaded
//const int maxInputLength = 200; //max ammount of data you can send in one line
//const int maxFileSize = 8192; //max of 8Kbytes per file size
char getINint();
void printShape(int color, int x, int y, int length, int height);
void calculator(char* varA, char* varB,char* operation);
void inputprompt(char* cin,char* cin2);
void outputprompt(char* cin,char* cin2,int buffer);
void infodisplay();
void hexdumper(int start,int end);
void hexdump(unsigned char *start, int span);
void mem_view(unsigned int* startAddress, int length);
void printsn(float k);
void floatToScientific(float num);
void mem_view(unsigned int* startAddress, int length);
unsigned long int checksum(char *data,unsigned int size);
long double expression(char* string, char** lastPosition);
void IntToScientific(int num);
void UIntToScientific(unsigned int num);
void switchbank(char banknumber);
void ADCPRINTVALUE(int channel,char relay);
void RTCPOKE();
void BIOSMENU();
unsigned char write_data(unsigned long int address,unsigned char *data,unsigned int size);
char*   getsSized(char *s,unsigned int size);

//used for IO, to set or reset a bit, you XOR the bit you want to set with the reg and then output the reg
//its safer, so it doesnt interfear with other bits
/* global vars breaking things again
//char OREG1;
//char IOREG2A;
//char IOREG2B;
char IOREG2C;

char IOREG3A;
char IOREG3B;
char IOREG3C;

char IOREG4A;
char IOREG4B;
char IOREG4C;

char IOREG5A;
char IOREG5B;
char IOREG5C;
*/
//long int tester;
//long int tester;

double ANS; //value for ans
char gpiocount;
int usermem;
char *gets(char *);
void Sky();
char memorydisplay; //to enable or disable the memory viewer
	char  EF1func=(char )0xfff0;
	char  EF2func=(char )0xfff1;
	char  EF3func=(char )0xfff2;
	char  EF4func=(char )0xfff3;
	char  ADCIO=(char )0xfff4;
	char  baudrate=(char )0xfff5;
	int progmemorysize;

//IO variables


//end of IO variables

//location consts
/*
char * bank0=(char *)0x8000;
char * bank1=(char *)0xfff0;
char * bank2=(char *)0xfff0;
char * bank3=(char *)0xfff0;
*/
unsigned int atoui(register char* inputString)
{
    unsigned int numResult = 0;
    while(*inputString >= '0' && *inputString <= '9') {
        numResult *= 10;
        numResult += *inputString - 48;
        inputString++;
    }

    return numResult;
}

//any code in any banks needs this there too

long double ADCGETVOLTAGE(int channel){
	//long double  ADCERROR=(long double)0xf000;
	int i;
	int ADCHEX;
	long double ADCVOLTAGE;
	out(1,0x01); //port b
			out(ADCIO,channel);//(0)X channel
			out(1,0x02); //port c
			out(ADCIO,0x80);
			out(ADCIO,0x00);
			out(1,0x01); //port b
			for(i=0;i<300;i++){
				out(ADCIO,0x80);
				out(ADCIO,0x00);
			}
			out(1,0x00); //port a
		
			
			
			ADCHEX = inp(ADCIO);
			ADCVOLTAGE = ADCHEX*0.01960784313;
			ADCVOLTAGE -= 0.032; //remove the error
			out(1,0x01); //port b
			out(ADCIO,0x00);
	return ADCVOLTAGE;
	
	
}







/*

0xE3,0x69,0x10,0xE2,0xF8, 0x00, 0xA0, 0xB0, 0xE0, 0xD0}

sep 3
out 1 db 10
sex 2

ldi 0
plo 0
phi 0

sex 0
sep 0

*/
/*
void returnerfrombanks(){//dumy return tool so we can come back to the bios without rebooting, but we need 0x7777 to be free
	asm(" SET SAVELOC,$\n");
	asm("	org 0x7FFC\n");  //todo:: add a requester tool, so we can go here and request either to return to the bios or get something from here like the printf
	asm("	lbr postboot\n");//we have an 
	asm(" org SAVELOC\n");
}
*/
/* //patina: this is huge

/*
 * Convert a string to an unsigned long integer.
 *
 * Ignores `locale' stuff.  Assumes that the upper and lower case
 * alphabets and digits are each contiguous.
 */
 
 /*
extern int errno;
 
#define UC(c)	((unsigned char)c)
char isupper (unsigned char c)

{

    if ( c >= UC('A') && c <= UC('Z') )

        return 1;

    return 0;

}
 */
 /*
int
isalpha(c)
	int c;
{

	return ((c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z') ? 1 : 0);
}
*/
 /*
int
isdigit(c)
	int c;
{

	return (c >= '0' && c <= '9' ? 1 : 0);
}
 */
 
 /*
unsigned long
strtoul(nptr, endptr, base)
	const char *nptr;
	char **endptr;
	register int base;
{
	register const char *s = nptr;
	register unsigned long acc;
	register int c;
	register unsigned long cutoff;
	register int neg = 0, any, cutlim;


	do {
		c = *s++;
	} while (isspace(c));
	if (c == '-') {
		neg = 1;
		c = *s++;
	} else if (c == '+')
		c = *s++;
	if ((base == 0 || base == 16) &&
	    c == '0' && (*s == 'x' || *s == 'X')) {
		c = s[1];
		s += 2;
		base = 16;
	}
	if (base == 0)
		base = c == '0' ? 8 : 10;
	cutoff = (unsigned long)ULONG_MAX / (unsigned long)base;
	cutlim = (unsigned long)ULONG_MAX % (unsigned long)base;
	for (acc = 0, any = 0;; c = *s++) {
		if (isdigit(c))
			c -= '0';
		else if (isalpha(c))
			c -= isupper(c) ? 'A' - 10 : 'a' - 10;
		else
			break;
		if (c >= base)
			break;
		if (any < 0 || acc > cutoff || acc == cutoff && c > cutlim)
			any = -1;
		else {
			any = 1;
			acc *= base;
			acc += c;
		}
	}
	if (any < 0) {
		//acc = ULONG_MAX; //Patina: i have no idea
		//errno = ERANGE;
	} else if (neg)
		acc = ~acc; //Patina: replaced - with ~
	if (endptr != 0)
		*endptr = (char *)(any ? s - 1 : nptr);
	return (acc);
}
*/
/*

//to make return

0xE3,0x61,0x00,0xE2,0xF8, 0x77, 0xA0, 0xB0, 0xE0, 0xD0

sep 3
out 1 db 00
sex 2

ldi 0
plo 0
ldi 1
phi 0

sex 0
sep 0
//basicly, we going to 0x7777

*/

//IO regs

//adding functions
/*
char getINint(){//will allow for a running code to pause upon user input
	char sccINTSTATUS = 0;
	char * flag=(char *)0xfff0; //fetch the piece of ram of the main code, this is far from the 0xEEEE of the stack
	if(*flag == 'I'){
		out(4,0x05); //ISR
		sccINTSTATUS = inp(6);//fetch interrupt


	}else{
		sccINTSTATUS = 0;
	}

	//asm("	XIE ;allow for interrupts \n"); //toggle interrupts back on
	//asm("	CIE \n");
	return(sccINTSTATUS);
}
*/

int randomizer(int min, int max)
{
    int range = max - min;
    return min + rand(rand(rand(rand()))) % range;
}

/*
@return A shared pointer to a random MOTD
*/
void randomMOTD(char *buffer)
{
    const char error[] = "se estás a ler isto, o código falhou\n";
    const char *arr[] = {
        "Sabias que o 11-ETC é o melhor?\n",
        "Marta fez isto originalmente como uma piada, mas acabou por vender duas cópia desta unidade!\n",
       // "Estas mensagens aleatórias ocupam um pouco de espaço.\n",
       // "Há muitas funções escondidas!!\n",
       // "Isto é um exemplo de um sistema operativo.\n",
      //  "Operacional e pronto para controle.\n",
       // "Tenta alimentar isto com batatas!\n",
        "As primeiras versões do SBC1806 era o SBC1802 e tinha apenas 2Kbytes de ROM e 256Bytes de RAM.\n",
       // "Este programa cabe em 27Kbytes e usa pouca RAM.\n",
        "Se o teu terminal suportar, há texto colorido, permitindo criar imagens!\n",
        //"Não consomas mais do que 1A no SBC1806, se não o regulador ficara instavel!\n",
        "Já tentaste desligar e voltar a ligar?\n",
        //"MTxunil\n",
        "Usa 'clear' para limpar o ecra!\n",
       // "Não é um microcontrolador! É um microprocessador, e não é um arduino tambem..\n",
       // "O processador pode operar desde 0Hz ate 4Mhz, mas aqui pode funcionar so desde 1Mhz ate 4Mhz.\n",
        //"Marta anda a fazer uma versão de 32-bit e 64-bit do CDP1806.\n",
       // "Sem FPGAs!\n",
       // "WAIT pausa o processador. Achei que achasses isso interessante.\n",
       // "CLEAR reseta o processador mas não os outros ICs.\n",
        //"932 ilhas, 481 vias, 6264 segmentos de pistas e 287 redes, que confusão!!\n",
       // "Isto não deveria aparecer...\n",
        //"Tenta transferir mais RAM!\n",
       // "Tudo é uma máquina de fumo se usada de forma errada o suficiente.\n",
       // "Usa a lingua C!!\n",
        //"RS232 incluido!\n",
        //"https://www.pingodoce.pt/receitas/coleccoes/receitas-de-bolos/\n",
       // "https://www.youtube.com/watch?v=dQw4w9WgXcQ\n",
        //"Para acessar IO, usa os comandos 'output' e 'input'.\n",
        "Para mais textos como estes, usa 'motd'.\n",
       // "Possivelmente funcional!\n",
       // "Putty tem melhor experiencia de uso, mas realTerm tem a capacidade de carregar códigos.\n",
       // "Na expocolgaia 2023, Marta não fez uma demonstração prática pois o SBC1802 tinha sido danificado por ESD e partes como o socket da ROM serem SMD e muito pequenos.\n",
       // "Usando comandos para controlar o timer/contador do CPU, é possivel calcular a velocidade do CPU mas tambem fazer multi tasking.\n",
		"Se backspace não funciona, usa ctrl+H\n",
       // "ENQ é uma sequencia enviada para saber qual é o terminal a ser utilizado no momento.\n",
       // "Se fosse possivel serializar os bytes de imagens e enviar, o código seria mais rápido.\n"
        
    };


    int number = randomizer(0, sizeof(arr) / sizeof(char *));

    const char *output = NULL;
    if (number >= 0 && number < sizeof(arr) / sizeof(char *)) {
        output = arr[number];
    } else {
        output = error;
    }

    strcpy(buffer, output);
}

char *
strtok(s, delim)
char *s;
const char *delim;
{
    char *spanp;
    int c, sc;
    char *tok;
    static char *last;


    if (s == 0x00 && (s = last) == 0x00) {
        return (0x00);
    }

    /*
     * Skip (span) leading delimiters (s += strspn(s, delim), sort of).
     */
cont:
    c = *s++;
    for (spanp = (char *)delim; (sc = *spanp++) != 0;) {
        if (c == sc) {
            goto cont;
        }
    }

    if (c == 0) {		/* no non-delimiter characters */
        last = 0x00;
        return (0x00);
    }
    tok = s - 1;

    /*
     * Scan token (scan for delimiters: s += strcspn(s, delim), sort of).
     * Note that delim must have one NUL; we stop if we see that, too.
     */
    for (;;) {
        c = *s++;
        spanp = (char *)delim;
        do {
            if ((sc = *spanp++) == c) {
                if (c == 0) {
                    s = 0x00;
                } else {
                    s[-1] = 0;
                }
                last = s;
                return (tok);
            }
        } while (sc != 0);
    }
    /* NOTREACHED */
}



/*
double atof(const char *s)
#define isdigit(c) (c >= '0' && c <= '9')
{
    // This function stolen from either Rolf Neugebauer or Andrew Tolmach.
    // Probably Rolf.
    double a = 0.0;
    int e = 0;
    int c;
    while ((c = *s++) != '\0' && isdigit(c))
    {
        a = a*10.0 + (c - '0');
    }
    if (c == '.')
    {
        while ((c = *s++) != '\0' && isdigit(c)) {
            a = a*10.0 + (c - '0');
            e = e-1;
        }
    }
    if (c == 'e' || c == 'E')
    {
        int sign = 1;
        int i = 0;
        c = *s++;
        if (c == '+') {
            c = *s++;
        } else if (c == '-') {
            c = *s++;
            sign = -1;
        }
        while (isdigit(c)) {
            i = i*10 + (c - '0');
            c = *s++;
        }
        e += i*sign;
    }
    while (e > 0)
    {
        a *= 10.0;
        e--;
    }
    while (e < 0)
    {
        a *= 0.1;
        e++;
    }
    return a;
}

*/
/*
void DrawLine(int lenth,char code[16])  //lenth in spaces, code is the code \033[48;2;R;G;Bcm
{
    int i;

    //printf("\033[48;2;%d",r,";%d",g,";%d",b,"m");
    //printf("\033[48;2;%c;%c;%cm", r, g, b);
    printf("%s",code);
    for(i=0; i!=lenth; i++) {

        printf(" ");

    }

    printf("\n");

}*/


void iocfgread(){
	//printf("IO config has been loaded!\n"); //Formfeed (also: New page NP)
   //out(1,0x03);
   // printf("IO 2 %x\n",inp(2));

   // out(1,0x03);
   // printf("IO 3 %x\n",inp(3));

    //out(1,0x03);
   // printf("IO 4 %x\n",inp(4));

    //out(1,0x03);
   // printf("IO 5 %x\n",inp(5));
    //out(1,0x03);
}

void iocfgtest(){
		gpiocount = 0;
		
	if(inp(2)==0x00) {
        printf("Chip 2 not present\n");
    } else {
        printf("Chip 2 present\n");
        gpiocount++;
    }
    out(1,0x03);
    if(inp(3)==0x00) {
        printf("Chip 3 not present\n");
    } else {
        printf("Chip 3 present\n");
        gpiocount++;
    }
    out(1,0x03);
    if(inp(4)==0x00) {
        //printf("Chip 4 not present\n");
		printf("Chip 4 present\n"); //somehow the chip cant be read
		gpiocount++;
    } else {
        printf("Chip 4 present\n");
        gpiocount++;
    }
    out(1,0x03);
    if(inp(5)==0x00) {
        printf("Chip 5 not present\n");
    } else {
        printf("Chip 5 present\n");
        gpiocount++;
    }
	printf("%x\n",TEF1());
	printf("%x\n",TEF2());
	printf("%x\n",TEF3());
	printf("%x\n",TEF4());
}


/*

	unsigned char spi_transfer(unsigned char data) {
	int i = 0;
	unsigned char datain = 0x00;
   // output(0x00);
   // output(0x04);
   out(1,0x01);//change of plans, port B is output and C is output
	
				//0  000 010 1 //set bit 2 high //set SCL HIGH
				//0  000 ||| +set/reset
				//0  000 ||+--bit select
				//0  000 |+---bit select
				//0  000 +----bit select

    for(i = 0; i < 8; i++) {
		
        if(data & 0x80) {
			//8421
						 // - |||+ 0100 0000
			out(1,0x01); //be on port B
			out(3,0x4F); 
			out(3,0x6F); //set bit 5 high ;; our SCK 0 0101

            //out(3,0x20);//turn off bit 5
			//out(3,0x00);//turn off bit 6
			
        }else {
			//8421
           out(1,0x01);//port B
           out(3,0x2F); //set bit 5 high ;; our SCK 0 0101
		   //out(3,0x00);//turn off bit 5
        }
		datain <<= 1;//shift 1
		out(1,0x02);//port C
		if(inp(3)&0x80){
			datain|=0x01;
		}else{
			datain|=0x00;
		}
		out(1,0x01); //be on port B
		out(3,0x2F);//turn off bit 5
		out(3,0x0F);//turn off bit 5
        data <<= 1;
		//printf("data post shift %x\n",data);
		//printf("data inputed %x\n",datain);
    }
	out(1,0x01);
	return datain;
    //output(0x00);
}
*/
unsigned char spi_transfer2(unsigned char data) {
	int i = 0;
	unsigned char datain = 0x00;
   // output(0x00);
   // output(0x04);
   out(1,0x02);//change of plans, port B is output and C is output
				//port C upper is input, lower is output
				//0  000 010 1 //set bit 2 high //set SCL HIGH
				//0  000 ||| +set/reset
				//0  000 ||+--bit select
				//0  000 |+---bit select
				//0  000 +----bit select

    for(i = 0; i < 8; i++) {
		
        if(data & 0x80) {
			//8421
						 // - |||+ 0100 0000
			out(1,0x02); //be on port B
			out(4,0x04); 
			out(4,0x06); //set bit 5 high ;; our SCK 0 0101

            //out(3,0x20);//turn off bit 5
			//out(3,0x00);//turn off bit 6
			
        }else {
			//8421
           out(1,0x02);//port B
           out(4,0x02); //set bit 5 high ;; our SCK 0 0101
		   //out(3,0x00);//turn off bit 5
        }
		datain <<= 1;//shift 1
		out(1,0x02);//port C
		if(inp(4)&0x80){
			datain|=0x01;
		}else{
			datain|=0x00;
		}
		out(1,0x02); //be on port B
		out(4,0x02);//turn off bit 5
		out(4,0x00);//turn off bit 5
        data <<= 1;
		//printf("data post shift %x\n",data);
		//printf("data inputed %x\n",datain);
    }
	out(1,0x02);
	out(4,0x00);//turn off 
	return datain;
    //output(0x00);
}

/*
	//Patina: unused for now
	char TTYINPUT[512]; //Serial input from RS232 port
	int TTYINPUTCOUNT; //char count of TTYINPUT
	
	*/
void main()
{
	//int registerD=0;
	//int seconds=0;
	//int minutes=0;
	//int hours=0;
	
	char *test;
    char buffer[32]; //now replaced with TTYINPUT[512]
	char junkbuffer[4096];//small buffer for functions that may need one
	
    char motdmessage[256];
    int randomNumber = rand(rand());
    char str[20]; // declaring a character array
    char cin[4];
    char cin2[4];
	//int SPICOMMAND = 0x00;
	//int SPIBYTE = 0x00;
	//char LOADmem[16384];
	char *progmemory = (char*)0x8000;
    char *token;
    int i = 0;
	//int *malloctest;
    char command[64], var1[64], var2[64], var3[64], var4[64];
    char * flag=(char *)0xfff0; //point to a piece of ram
	int * externalprogramid=(int *)0xffe0; //point to this address, this has the ID of the code to run on the other banks
	char * bankbootindication=(char *)0xffe1; //point to this address, this has the boot/bank return, when its the first boot data is random, but from bank return, its 0x32
    
	int rgbloop=0;
    char *commandpt = command;
    char *var1pt = var1;
    char *var2pt = var2;
    char *var3pt = var3;
    char *var4pt = var4;
	int outputbuffer = 0;
	long double expressionresultholder = 0;
	char ADCHEX = 0;
	long double ADCVOLTAGE = 0;
    gpiocount = 1; //because of SCC2692
    memorydisplay = 0; //so it shuts up
    *flag=0; //set flag to 0 //
	*externalprogramid=0;//0 is BIOS ID
	
	/*
	for(i=0;i<sizeof(TTYINPUT);i++){
		TTYINPUT[i]=0x00;//clear buffer on reboot
	}
	TTYINPUTCOUNT=0; //we shouldnt have any chars there yet */
    usermem=0;
	//fault here
    asm("	req\n"); //turn Q off
	asm("	seq\n");
    asm("	ldAD R1,_INTHANDLER  ;.. R1 = INTERRUPT PC\n"); //set R1 to point to the interrupt routine
	//asm("	ldAD R1,_INT2  ;.. R1 = INTERRUPT PC\n");//set R1(interrupt counter) to execute our subroutine
	out(1,0x03);
    out(2,0x80); //10010001 //so port C bits 0-3 are inputs for setting or quiting code
	out(4,0x80); //IO 4 is now having its port A as bidirectional <-> 1100 0000 0xC0
	//out(4,0x88);// 10001000
    out(3,0x80);
   // out(5,0x89);
    out(1,0x00);
	
	//out(1,0x01);
	//out(4,0xFF);//init this for parallel bus
 #if(SCC == 1 || SCC == 2)
    //printf("Starting IO....\n");
	


	
	
	//out(ADCIO,0x91);//override to make it accept the ADC
	
	
    asm("	seq\n"); //turn Q on

    out(1,0x01);//select port b
	//controlWrite(0x01);
    out(4,0x02); //CRA
    out(6,0x10); // 00010000 set pointer to MR1A

    out(4,0x00); //adress 00 //MR1A//MR2A
    out(6,0x53); //0101 0011 decimal 83 hex 0x53
    out(6,0x07); //00 0 0 0111 //normal,no rts control,no cts control, 1 stop bit decimal
	
	
	//this has been serialized
	

    out(4,0x02); //CRA
    out(6,0x05); // 0000 0101


	
	
    out(4,0x01); //csra
    out(6,0xBB); //0100 0100 300 bound but in test mode wich is the one we use, its 28.8Kboundrate       //9600 bound rate is 1011 1011 we use 9600 for now 18/11/2023
	//out(6,0x66);    //0110 0110 1200 baud but when in BRG test it gives us 115200baudrate
	//out(6,0xCC); //1100 1100 19200 baud ACR[7]=1 // ACR[7]=0 then 38.4K
	
	//out(4,0x04);
	//out(6,0x80); //set ACR[7]=1, set to 0x00 for ACR[7]=0
	
    out(4,0x05); //R5 :: IMR interrupt mask register
    out(6,0x02);//0000 0010 //for when only Rx of channel A is ready

    out(4,0x02); //CRA
    out(6,0x05); // 0000 0101
	

	
    inp(6); //read register two wich changes to BRGTEST, to make it from 300 bound to 28.8Kboundrate
	
	out(4,0x04);
	out(6,0x80); //set ACR[7]=1, set to 0x00 for ACR[7]=0
	
	
    delay(1000);
    asm("	req\n"); //turn Q on
	
	printf("canal 1 ligado\n");
	out(1,0x01);//select port b
	//controlWrite(0x01);
	out(4,0x0A); //CRB
    out(6,0x10); // 00010000 set pointer to MR1A
	out(4,0x08); //adress 08 //MR1b//MR2b
    out(6,0x53); //010 10 0 11 decimal 83 hex 0x53
    out(6,0x07); //00 0 0 0111 //normal,no rts control,no cts control, 1 stop bit decimal
	
	out(4,0x0A); //CRB
    out(6,0x05); // 0000 0101
	out(4,0x09); //csrb
    out(6,0xBB); //0100 0100 300 bound but in test mode wich is the one we use, its 28.8Kboundrate       //9600 bound rate is 1011 1011 so BB
	out(4,0x0A); //CRB
    out(6,0x05); // 0000 0101
	
	
	
	printf("canal 2 ligado\n");
	
	out(4,0x04); //Aux. Control Register (ACR)
	out(6,0x60);//0110 0000
	
	out(4,0x00); //C/T Upper Preset Value (CRUR)
	out(6,0x01);
	out(4,0xFF); //C/T Lower Preset Value (CTLR)
	out(6,0x0A);
	out(4,0x01); //Start Counter Command
	inp(6);
	out(4,0x0D); //Output Port Conf. Register (OPCR)
	out(6,0x04); //C/T OUTPUT
	
#endif 
	//iocfgread();
   // iocfgtest();

    //asm("	XIE\n");
    //asm("	CIE\n");
    //strtok("hello world"," ");
   // delay(1000);
    printf("\033[2J");
    printf("\033[H"); //move cursor to home position, 0,0, so the top of the display
    //delay(200);
    //
    printf("\x1b[0m");

/*
	if(*bankbootindication==0x32){
		printf("Reset detectado\n");
	}else{
		printf("Primeiro arranque\n");
	}
*/
	//out(1,0x03);
   // out(2,0x91); //10010001 //so port C bits 0-3 are inputs for setting or quiting code
	//out(4,0xC8); //IO 4 is now having its port A as bidirectional <-> 1100 0000 0xC0
	//out(4,0x88);// 10001000
   // out(3,0xC0);
   // out(5,0x89);
   // out(1,0x00);
	
	out(1,0x01);
	
	//controlWrite(0x01);
	//out(4,0xFF);//init this for parallel bus
    printf("Olá Marta\n");
    *bankbootindication=0x32;
    printf("Usa 'help' para lista de comandos\n");
    printf("Sem erros por enquanto\n");
    printf("[39;49m \n");
    randomMOTD(motdmessage);
    printf(motdmessage); //random MOTD
    printf("\033[48;2;37;155;36m User memory.\033[m\n");
    printf("Used:%dB/26kb\n",usermem);
   /* printf("\033[48;2;0;188;212m Heap and boundry memory.\033[m\n");
    printf("Used:0B/128B\n");
    printf("\033[48;2;255;238;88m Stack memory.\033[m\n");
    printf("Used:12B/2kb\n");
    printf("\033[48;2;191;54;12m BIOS memory.\033[m\n");
    printf("Used:1B/4kb\n");*/
    printf("this info has been disabled.\n");
    printf("see help to see how to re enable it.\n");
	//rtc_check();
    while(1) {


	if(ADCIO<2||ADCIO>=5){//keep between IO2 to IO4
		
		ADCIO=0x02;
	}

programbreak: //for programs that support pressing x to force them to stop

#if(DEBUG==1)
        printf("DEBUG MODE IS ON\n");
#endif
/*
		if(*bankbootindication!=0x32){
			printf("first boot\n");
		}else{
			printf("reset detected\n");
		}
		*/
		#if(SCC==2)
		setINTregister(0x02);
		#endif
		asm("postboot:\n");//flag used in the returnerfrombanks tool
		asm("	req\n");
		*bankbootindication=0x32; //so the computer from now on knows it has booted
        printf("Ready!\n");

        if(memorydisplay == 1) {
            printf("\033[48;2;37;155;36m User memory.\033[m\n");
            printf("Used:%dB/26kb\n",usermem);
           /* printf("\033[48;2;0;188;212m Heap and boundry memory.\033[m\n");
            printf("Used:0B/128B\n");
            printf("\033[48;2;255;238;88m Stack memory.\033[m\n");
            printf("Used:12B/2kb\n");
            printf("\033[48;2;191;54;12m BIOS memory.\033[m\n");
            printf("Used:1B/4kb\n");
            printf("this info has been disabled.\n");
            printf("see help to see how to re enable it.\n");*/
        }

        //printf("%f\n",(float)2.22);

        printf(">");
        //cin = getc();
       // gets(buffer);//changed from buffer to TTYINPUT
	   
	   gets_asm(buffer);
	   printf("\n");
		asm("pastgets:\n");//used so after interrupts from this
		//asm("	ldAD R1,_INT2  ;.. R1 = INTERRUPT PC\n");//set R1(interrupt counter) to execute our subroutine
		 asm("	ldAD R1,_INTHANDLER  ;.. R1 = INTERRUPT PC\n"); //set R1 to point to the interrupt routine
		// TTYINPUTCOUNT=0;//added this so when read the stack it clears it
	   // ramInit();//removed as something feels wrong
        //token system
        token = strtok(buffer, " ");//changed from buffer to TTYINPUT
        strcpy(command, token);
        memset(var1,0,sizeof(var1)); //clear out this buffers
        memset(var2,0,sizeof(var2));
        memset(var3,0,sizeof(var3));
        memset(var4,0,sizeof(var4));  ////we should optimize this
        for (i = 0; i < 4; i++) {
            token = strtok(NULL, " ");
            if (token != NULL) {
                switch (i) {
                case 0:
                    strcpy(var1, token);
                    break;
                case 1:
                    strcpy(var2, token);
                    break;
                case 2:
                    strcpy(var3, token);
                    break;
                case 3:
                    strcpy(var4, token);
                    break;
                case 4:
                    break;//if too many arguments are sent, kill them
                }
            } else {
                //  printf("Error: Insufficient input\n");
                // return 1;
            }
        }//end of it
	


        //switch(cin){
        if(strcmp(command,"CSH")==0) {
			
			printf("CS=5V\n");
			out(1,0x00);
			//controlWrite(0x01,0);
			out(4,0x80); //1000 0000
        } else if(strcmp(command,"CSL")==0) {
            
			printf("CS=0V\n");
			out(1,0x00);
			out(4,0x00); //0000 0000
			//printf("Enter text\n");
			
		//} else if(strcmp(command,"spi")==0) {
            
			//printf("Sent: %x , received: %x \n",atoui(var1),SPI_TRANSFER(atoui(var1)));
			//printf("use SPI\n");
			//if(atoi(var1)>0){
			//SPI_SEQUENCE_TRANSACTION(atoi(var1),var2);
		   // }else{
			//	printf("there has to be atleast 1 byte per transfer\n");
				
			//}
			
		}else if(strcmp(command,"sqrt")==0) {
			
			raiz_quadrada(atofinternal(var1));
			
		}else if(strcmp(command,"sin")==0) {
			
			sin_graus(atofinternal(var1));
		}else if(strcmp(command,"cos")==0) {
			cos_graus(atofinternal(var1));
			
		}else if(strcmp(command,"tan")==0) {
			tan_graus(atofinternal(var1));
			
		} else if(strcmp(command,"SPI")==0) {
            
			printf("Sent: 0x%x , received: 0x%x \n",atoui(var1),spi_transfer2(atoui(var1)));
			
		
			
		} else if(strcmp(command,"write")==0) {
			/*
			//uses IO4 port A as bidirectional
			out(1,0x00);
			out(4,atoi(var1));//get this ready
			out(1,0x01);
			out(4,0xDF); //1101 XXXX => this 0 bit is used to prepare the io
			delay(1);
			out(4,0x5F);//bit 7 goes low, wich represents WR going low(TIE THIS TO !ACK)(TIE !OBF or this pin to your chip !WR pin) (and bit 5 stays low as before)
			out(4,0xFF);
			out(1,0x00);
			*/
		} else if(strcmp(command,"read")==0) {
			/*
			out(1,0x01);
			out(4,0xEF); //bit 4 goes low, so the IO prepares to be read
			delay(1);
			out(4,0xAF); //now bit 6 also goes low to latch data
			out(1,0x00);
			printf("Got:%x\n",inp(4));
			out(1,0x01);
			out(4,0xFF);
			out(1,0x00);*/

        }else if(strcmp(command,"help")==0) {
            //case 'h':
            //printf("%c\n",cin);
            printf("\n");
            printf("help:\n basic:\n");
            printf("input <IO chip> <Port>: reads IO ports\n");
            printf("output <IO chip> <Port> <Value>: Acess to IO outputs\n");
            printf("random <opt1: min> <opt2: max>: randomize the random value\n");
            printf("about: credits and such\n");
            printf("clear: wipes screen\n");
            printf("info: returns information about the SBC1806 state\n");
            printf("motd: mensagem aleatória\n");
			printf("BIOS: acessa as definições da BIOS\n");
			printf("fract:  descobre :)\n");

			//asm("	dw(postboot)\n");
            //printf("usa rand em output e.g: output 2 c rand <ciclos> <delay>, para mandar um sinal aleatorio\n");
            //	break;
            //for h
			
			
		}else if(strcmp(command,"fract")==0) {
            //case 'r':

           // printf("\033[2J");
            //printf("\033[H"); //move cursor to home position, 0,0, so the top of the display
            //break;
			
			mandelbrot();
			
			
		
		} else if(strcmp(command,"LOAD")==0) {
			
			if(atoi(var1)<=0){
				printf("Error: allocation must be larger than 0.\n");
				
			}else{
				printf("75ms between chars required.(100ms for better results)\n");
				//getsSized(progmemory,atoi(var1));
				getsSized_asm(progmemory,atoi(var1));
				//test =  (char*)malloc(atoi(var1));
				//if(test){
				//getsSized(test,atoi(var1));
				printf("Código carregado");
				printf("Recebidos: %d bytes\n",atoi(var1));
				printf("Checksum: 0x%lx\n",checksum(progmemory,atoi(var1)));
				progmemorysize=atoi(var1);
				
			}
				//}else{
					
				//	printf("Allocation error: No free Memory\n");
					
				//}
				/*
				switch(getc()){
					
					case 'y':
					asm("	seq\n");
					//memcpy((void *)0x8001, LOADmem,atoi(var1));//copy the switching code to RAM
					asm("	req\n");
					printf("Loaded code, executing....\n");
					asm("	lbr 0x8001\n");//execute the code in ram
					
					case 'n':
					printf("code deleted\n");
					break;
					
					default:
					printf("not valid key, closing\n");
					
				}
				*/
				
				
			
			
		} else if(strcmp(command,"READ")==0) {
			if(atoi(var1)<=0){
				printf("Error: you must read one or more bytes (1-16Kbytes)\n");
			}else{
				
				for(i=0;i<atoi(var1);i++){
					printf("%cx,",progmemory[i]);
				}
				printf("Pronto\n");
				printf("tamanho: %d bytes\n",progmemorysize);
				printf("Checksum: %lx\n",checksum(progmemory,progmemorysize));
				
			}
			
		} else if(strcmp(command,"RUN")==0) {
			//if(progmemorysize<=0){
			//	printf("Error: code size is 0 Bytes, you need to load the code first by using: 'LOAD <size>'\n");
			//}else{
				
			printf("executando %d bytes....\n",progmemorysize);
			
			asm("	lbr 0x8000\n");//execute the code in ram
			//}
			
		} else if(strcmp(command,"ERASE")==0) {
			
			printf("Erasing %d Bytes\n",progmemorysize);
			for(i=0;i<progmemorysize;i++){
				progmemory[i]=0xFF;//hard wipe
			}
			//free((unsigned char *)test);
			printf("Done\n");
			progmemorysize=0;
			
		} else if(strcmp(command,"STORE")==0) {
			
			if(atoi(var1)<0||atoi(var1)>16){
				printf("ID goes from 0 to 16\n");
			}else{
				
				if(atoi(var2)<0||atoi(var2)>16384){
					printf("size of code to write must be greater than 0 and at most 4096\n");
				}else{
					//unsigned int offset=33*FileID;
					
					//a 8K file does 2 writes
					write_data((unsigned long int)16384*atoi(var1),(unsigned char*)progmemory,4096);//progmemory[i*4096] so we read each sector
					
				}
			}
			
			
		} else if(strcmp(command,"FETCH")==0) {
			
			if(atoi(var1)<0||atoi(var1)>16){
				printf("ID goes from 0 to 16\n");
			}else{
				if(atoi(var2)<0||atoi(var2)>16384){
					printf("size of code to read must be greater than 0 and at most 16384\n");
				}else{
				//unsigned int offset=33*FileID;
				read_data((unsigned long int)16384*atoi(var1),atoi(var2),progmemory);
				}
			}
			
		} else if(strcmp(command,"SCAN")==0) {
			
			if(atoi(var1)<0||atoi(var1)>16){
				printf("ID goes from 0 to 16\n");
			}else{
				if(atoi(var2)<=0||atoi(var2)>4096){
					printf("size of code to read must be greater than 0 and at most 4096\n");
				}else{
					//unsigned int offset=33*FileID;
					read_data((unsigned long int)16384*atoi(var1),atoi(var2),junkbuffer);
					printf("Checksum: %lx\n",checksum(junkbuffer,atoi(var2)));
				}
			}
		//unsigned char write_data(unsigned long int address,unsigned char *data,unsigned int size){
		//unsigned char read_data(unsigned long int address,unsigned int count,char *databuffer){
		
		} else if(strcmp(command,"BIOS")==0) {
			
		BIOSMENU();
			

        } else if(strcmp(command,"silence")==0) {
            memorydisplay = 0;
            printf("memory display has been disabled.\n");
        } else if(strcmp(command,"shout")==0) {
            memorydisplay = 1;
            printf("memory display has been enabled.\n");
       // } else if(strcmp(command,"changelog")==0) {/*
           // printf("25/09/2023: melhoramentos no código para suporte de comandos em série\n");
          //  printf("24/09/2023: arranjo de cores e imagens.\n");
          //  printf("12/09/2023: troca comandos de letras como 't' ou 'h' com 'test' ou 'help' respetivamente.\n");
           // printf("6/09/2023: adicionado comandos para renderizar imagens.\n");
           // printf("10/07/2023: primeira versão.\n");
//*/
       /* } else if(strcmp(command,"hexdump")==0) {


            //if(atoui(var1)<(unsigned int)0 || atoui(var1)>(unsigned int)0xffff){
            //	printf("Erro: enderço inicial vai de 0 a 65535");
            //}else{
            //	if(atoi(var2)<0){
            //		printf("Erro: comprimento vai de 1 a 16");
            //	}else{
            mem_view((unsigned int *)atoui(var1),atoi(var2));
            //	}
            //}

*/
        } else if(strcmp(command,"info")==0) {

            infodisplay();



        }else if(strcmp(command,"motd")==0) {

            randomMOTD(motdmessage);
            printf(motdmessage); //random MOTD
        }else if(strcmp(command,"about")==0) {
           

            printf("\033[48;2;252;0;223m            \033[m\n");

            printf("\033[48;2;0;252;240m            \033[m\n");

            printf("\033[48;2;255;255;255m            \033[m\n");
            //printf("");
            printf("\033[48;2;0;252;240m            \033[m\n");
            //printf("");
            printf("\033[48;2;252;0;223m            \033[m\n");
            //printf("");
            printf("\033[0m");
            ///////////
            printf("Made by: MsAlPatina!\n");
            printf("Major thanks to: Bill, Grisses, nicky_5 and Zled!\n");
            printf("https://github.com/MsAlPatina\nhttps://github.com/Grissess\nhttps://github.com/bill2009\nhttps://github.com/zledtriac\nhttps://github.com/nicky-5\nhttps://github.com/MsAlPatina/SBC1806\n");
          
           

            //printf("\033[48;5;194m");
            //printf("  \n");
            printf("\033[0m");
        }



        else if(strcmp(command,"rgb")==0) {

            if(atoi(var1) <= 0) {
                printf("Erro: arg1 deve ser maior que 0 (define o numero de ciclos).\n");

            } else {
                if(atoi(var2)<=0) {
                    printf("Aviso: arg2 nulo defenido valor para 250ms.\n");
                    strcpy(var2,"250");
                } else {
                    printf("Party time!\n");
                }

                printf("\033[41m            \033[m\n");
                //printf("            \n");
                printf("\033[43m            \033[m\n");
                //printf("            \n");
                printf("\033[42m            \033[m\n");
                //printf("            \n");
                printf("\033[44m            \033[m\n");
                //printf("            \n");
                printf("\033[45m            \033[m\n");
                //printf("            \n");

                printf("\033[32;49m");
                printf("Embrace the rainbow!! \n");
                printf("Press c to stop\n");

                printf("\033[0m");

                //printf("%c",0x13); //so no sending stuff
                //while(getINint()){
				//out(1,0x01); //port B
                for(rgbloop=0; rgbloop<=atoi(var1)||!(inp(6) & 0x01); rgbloop++) {
                    //printf("%c\n",cin);
					//out(1,0x01); //port B
                    randomNumber = randomizer(1, 7); //cap it to 7
					randomNumber |= randomizer(16,240);
                    //printf("random number = %d\n",randomNumber);
                    out(1,0x00);
                    out(4,randomNumber);
                    delay(atoi(var2));
					out(1,0x01); //port B
					
					if(inp(6) & 0x01){
					
					out(1,0x01); //port B
					out(4,0x03); //select RXHA
					//buffer = inp(6);
						if(inp(6) == 'c'){
						asm("	lbr rgbbreaker\n");
						}
					}
                }
				asm("rgbbreaker\n");
                //}
				
                //printf("%c",0x11); //now you can send stuff
            }
        } else if(strcmp(command,"input")==0) {
            inputprompt(var1,var2);
        } else if(strcmp(command,"output")==0) {
				var3pt = var3;
				outputbuffer = (int)expression(var3pt,&var3pt);
            if(outputbuffer < 0 || outputbuffer > 255) {
                printf("Value to output goes from 0 to 255\n");
            }else if(strcmp(var3,"ans")==0){
				outputprompt(var1,var2,(int)ANS);
			} else {
				//printf()
				//var3pt = var3;
                outputprompt(var1,var2,outputbuffer);
            }
			
			
		} else if(strcmp(command,"sleep")==0) {	
			sleepMODE(atoi(var1),atoi(var2));
        } else if(strcmp(command,"random")==0) {
            //case 'r':
            //printf("%c\n",cin);

            if(atoi(var2) > atoi(var1)) {
                printf("%d\n",randomizer(atoi(var1), atoi(var2)));
            }

            printf("Rand used to be: %d\n",randomNumber);
            randomNumber = rand(rand());
            printf("Now rand is: %d\n",randomNumber);
            //break;
        } else if(strcmp(command,"clear")==0) {
            //case 'r':

            printf("\033[2J");
            printf("\033[H"); //move cursor to home position, 0,0, so the top of the display
            //break;
        }

        else if(strcmp(command,"beep")==0) {
            //case 'b':
            //printf("%c\n",cin);
            if(var1 == 0x00) {
                printf("Error on: arg1, expected value, got NULL.\n");
                printf("beep <beep time in ms.\n>");
            } else if(var1 != 0x00) {
				
				if(atoi(var2)==0){
					printf("Warning, no frequency, defaulting to 1Khz\n");
					
				}else{

					if(strcmp(var1,"ans")==0) { //take the value ANS of a previusly calculated value
						out(1,0x80);
						delay((int)ANS);
						out(1,0x00);
					} else {
						var1pt = var1;
						expressionresultholder = expression(var1pt,&var1pt);
							if((int)expressionresultholder <= 0) {
								printf("Error on: arg1, value cant be less or equal to 0.\n");
							//return 0x00;
							} else {

                       // var1pt = var1;
                        //ANS = expression(commandpt,&commandpt);
							for(i=0;i<1000*atoi(var1);i++){//so the frequency*the time in mseconds
								//so 500 would do a delay of 2ms (1000/500)
								out(1,0x80);
								delay(1);
								out(1,0x00);
								delay(1);
							}
						}
					}
                }
                //break;
            }
        }

        else if(strcmp(command,"shutdown")==0) {
            //case 's':
            printf("%c\n",cin);
            printf("\a"); //plays a sound on the terminal
            printf("Shutting down\n");
            //delay(2000);
            printf("\a"); //plays a sound on the terminal
     /*       out(1,0x00); //shut down all pins
            out(2,0x00);
            out(3,0x00);
            out(4,0x00);
            out(5,0x00);
            out(6,0x00);
            out(7,0x00);
			out(1,0x01); //shut down all pins
			out(2,0x00);
            out(3,0x00);
            out(4,0x00);
            out(5,0x00);
			out(1,0x02); //shut down all pins
			out(2,0x00);
            out(3,0x00);
            out(4,0x00);
            out(5,0x00);
*/
            out(1,0x00); //shut down all pins
            printf("Bye!\n");
            //asm("idl\n"); //we halt the CPU
            //exit(0); prints exit, then the value given, then goes in a while loop
            while(1) {
                asm("	req\n");
                delay(250);
                asm("	seq\n");
                delay(250);
            }
            //asm(" db 0\n");
            //asm("DW 00 \n");
            //break;
        }else if(strcmp(command,"sen")==0) {
            //printf("%f\n",sin(var1));
            printf("soonTM\n");
        } else {

            //calculator(command,var2,var1);
            commandpt = command;
            ANS = expression(commandpt,&commandpt);
			
			
			if(ANS==0){
				printf("%f\n",ANS);
			}else{
			
				if(ANS < 1000 & ANS >= 0.001) {
					printf("%f\n",ANS); //in this case, we pass the expression, it must be 2-34-54, not 2 - 34 - 54
				}
				if(ANS > 1000) {
					floatToScientific(ANS);
					printf("\n");
				}
				if(ANS < 0.001) {
					floatToScientific(ANS);
					printf("\n");
		
				}
			}
            //printf("command not recognised.\n");
            //printf("\a"); //plays a sound on the terminal

#if(DEBUG==1)
            printf("%s\n",buffer);
#endif

        }


    }


}

//functions used

char*   gets(char *s)
{

    char ch,*p;
    usermem = 0;
    p=s;
    while ( (ch=getc()) != '\r') { //replaced \n with 
	
        putc(0x13); //send DC3, so XOFF, stop TX decimal 19
        if(ch == 0x08) { //\b is used but i go with 0x08
            *s = '\0';
		  // *s--;
            if(s > p) {
                s--;    //added backspace compatability , so no more pressing enter to undo your error
            }
        } else {
            *s++ = ch;
            usermem++; //increment the memory pointer
        }
        printf("%c",ch);
        putc(0x11); //send DC1, so XON , allow TX decimal 17
    }
    printf("\n"); //this is so upon enter, it avoids things like 222You entered
    *s='\0';
	//TTYINPUTCOUNT=0;//added this so when read the stack it clears it
    return p; //return the address of S stored in P.
}

char*   getsSized(char *s,unsigned int size)//changes for speed
{
	
	unsigned int received=0;
	//int memoryreceivedbytes = 0;
    char ch,*p;
	progmemorysize=0;
    //usermem = 0;
    p=s;
//	
	asm("	seq\n");
    while (received < size) { //replaced \n with 
        //printf("%c",0x13); //send DC3, so XOFF, stop TX decimal 19
			ch = getc();
            *s++ = ch;
            usermem++; //increment the memory pointer
			received++;
			
			progmemorysize++;
			//printf("%l\n",sized);
			//printf("got:%x\n",ch);
			//printf("user memory:%d\n",usermem);
			//printf("got:%d\n",memoryreceivedbytes);
        }
       // printf("%c",ch);
        //printf("%c",0x11); //send DC1, so XON , allow TX decimal 17
    
   // printf("\n"); //this is so upon enter, it avoids things like 222You entered
    *s='\0';
	asm("	req\n");
    return p; //return the address of S stored in P.
}

/*
void setServoAngle(int angle)
{
    int pulseWidth = (angle * (2 - 1) / 180) + 1;
    int numPulses = 20 / 20; // Number of pulses in one period
    int i;
    for (i = 0; i < numPulses; i++) {
        // Set the servo pin high for the pulse width duration
        // and then set it low for the remaining period
        //printf("Angle: %d | Pulse: %d ms\n", angle, pulseWidth);
        delay(pulseWidth * 1000); // Convert to microseconds
        delay((20 - pulseWidth) * 1000); // Convert to microseconds
    }
}*/
/*
void printShape(int color, int x, int y, int length, int height)
{
    int xp;
    int yp;

    printf("\033[48;5;%dm", color); //setting the color.

    for(yp = y; yp < y + height; yp++) {  //for loop for the rows.
        printf("\033[%d;%dH", yp + 1, x + 1);  //set the cursor position, this is only required on the beginning of every line.
        for(xp = 0; xp < length; xp++) {  //for loop for the columns (characters).
            printf(" "); //just print the space.
        }
    }
}
*/

void outputprompt(char* cin,char* cin2,int buffer)
{

    //char cin[4];
    //char cin2[4];
    //char buffer[32];

    //printf("Select IO 1-7, other numbers wont work\n"); //reduced all switches and cases
    //printf(">");
    //gets(cin);
    //cin = getc();
    //printf("%c\n",cin);
    //printf("select port a,b,c\n");
    //printf(">");
    //gets(cin2);
    //cin2 = getc();
    //printf("%c\n",cin2);
    //printf("Enter value in decimal\n");
    //memset(buffer,0,32); //set the buffer to 0
    //printf(">");
    //gets(buffer);
    //printf("You entered in decimal %d\n",atoi(buffer));

    if(strcmp(cin2,"a")==0) {
        out(1,0x00);
    } else if(strcmp(cin2,"b")==0) {

        //case 'b':
        out(1,0x01);
    } else if(strcmp(cin2,"c")==0) {

        //case 'c':
        out(1,0x02);
    } else if(strcmp(cin2,"ctrl")==0) {
        out(1,0x03);

    } else {
        //default:
        printf("only a,b,c or ctrl\n");
        //break;
    }

	


    //switch(cin){

    //case '1':
    if(atoi(cin)>=1 ||atoi(cin)<=7) {
        out((char)atoi(cin),buffer);
        //break;
      //break;
    } else {
        //default:
        printf("invalid io it goes from 1-7 \n");
        //break;
    }



    //printf("\x1b[1;1H\x1b[2J"); //clear screen



    printf("Done\n");
    //break;


}


void inputprompt(char* cin,char* cin2)
{

    //for i
    //case 'i':
    //char cin[4];
    //char cin2[4];
    //printf("%c\n",cin);
    //printf("Read IO? (2-7)\n");
    //printf(">");
    /*printf("IO 2 %x \n",INP(2));
    printf("IO 3 %x \n",INP(3));
    printf("IO 4 %x \n",INP(4));
    printf("IO 5 %x \n",INP(5));
    printf("IO 6 %x \n",INP(6));
    printf("IO 7 %x \n",INP(7));*/

    //cin = getc();
    //gets(cin);
    //printf("%c\n",cin);
    //printf("Read Port? (a,b,c)\n");
    //printf(">");
    //gets(cin2);
    //cin2 = getc();
    //printf("%c\n",cin2);
    //switch(cin2){

    //case 'a':
    if(strcmp(cin2,"a")==0) {
        out(1,0x00);
    } else if(strcmp(cin2,"b")==0) {

        //case 'b':
        out(1,0x01);
    } else if(strcmp(cin2,"c")==0) {

        //case 'c':
        out(1,0x02);
    } else if(strcmp(cin2,"ctrl")==0) {

        out(1,0x03);
    } else {
        //default:
        printf("only a,b,c or ctrl \n");
        //break;
    }



    //printf("selected INP %d\n",atoi(cin));
    //printf("readed in hex: %x\n",inp(atoi(cin)));

    //internal i
    //switch(cin){

    //case '2':
    if(atoi(cin)>=2 || atoi(cin) <=7) {
        //printf("%c\n",cin);
        printf("Readed: %x \n",INP((char)atoi(cin)));
        //break;
    
        //break;
    } else {

        //default:
        //printf("%c\n",cin);
        printf("IO Not Recognized, it goes from 2-7\n");
        //break;


        //internal i

        //for i
        //break;
    }

}

void Sky()
{

    //DrawLine(12,"\033[48;2;255;255;255m");
    //DrawLine(12,"\033[48;2;255;255;255m");
    //DrawLine(12,"\033[48;2;100;100;100m");
    //DrawLine(12,"\033[48;2;100;100;100m");
    //DrawLine(12,"\033[48;2;100;100;100m");
    //DrawLine(12,"\033[48;2;100;100;100m");
    //DrawLine(12,"\033[48;2;100;100;100m");
    //DrawLine(12,"\033[48;2;100;100;100m");
    //DrawLine(12,"\033[48;2;0;255;0m");
    printf("\x1b[0m");//remove formatting
    //printf("\x1b[0m");//remove formatting
    //printf("\033[38;5;159;48;5;159m \033[38;5;159;48;5;159m \033[38;5;159;48;5;159m \033[38;5;159;48;5;159m ");
    //test sky
    //DrawLine(64,"\033[48;2;255;255;255m");
    //DrawLine(64,"\033[48;2;255;255;255m");
    //DrawLine(64,"\033[48;2;255;255;255m");
    //DrawLine(64,"\033[48;2;255;255;255m");

   // printf("Testing new format\n");
    //it uses \n to draw images that take the whole screen
    //printf("\033[48;2;175;255;255m\n\033[m\n");
    //printf("\033[48;2;175;255;255m\n\033[m\n");
    //printf("\033[48;2;175;255;255m\n\033[m\n");
    //printf("\033[48;2;175;255;255m\n\033[m\n");
    //printf("\033[48;2;175;255;255m\n\033[m\n"); //for this make it just repeat this same thing
    //like this

    //printf("\n");
   // printf("\n");
   // printf("\n");
    printf("\n");
    //test art 2
   /* 
   // printf("\033[48;2;228;228;228m                                \033[38;2;224;224;224;48;2;228;228;228m▄\033[38;2;223;223;223;48;2;228;228;228m▄\033[38;2;225;225;225;48;2;228;228;228m▄\033[48;2;228;228;228m             \033[m\n");
    //printf("\033[38;2;227;227;227;48;2;228;228;228m▄\033[38;2;220;220;220;48;2;228;228;228m▄▄▄▄▄▄\033[38;2;220;220;220;48;2;224;224;224m▄\033[48;2;220;220;220m                   \033[38;2;218;218;218;48;2;220;220;220m▄▄▄▄\033[38;2;219;219;219;48;2;220;220;220m▄\033[38;2;220;220;220;48;2;218;218;218m▄▄\033[38;2;220;220;220;48;2;219;219;219m▄\033[48;2;220;220;220m \033[38;2;218;218;218;48;2;220;220;220m▄\033[38;2;218;218;218;48;2;224;224;224m▄\033[38;2;218;218;218;48;2;228;228;228m▄▄▄▄▄▄▄\033[38;2;226;226;226;48;2;228;228;228m▄▄▄\033[m\n");
    printf("\033[48;2;228;228;228m                           \033[38;2;228;228;228;48;2;223;223;223m▄▄▄▄\033[38;2;228;228;228;48;2;225;225;225m▄\033[48;2;228;228;228m    \033[38;2;228;228;228;48;2;223;223;223m▄▄▄▄▄▄▄▄▄▄▄▄\033[m\n");
    printf("\033[38;2;228;228;228;48;2;220;220;220m▄\033[38;2;225;225;225;48;2;223;223;223m▄\033[38;2;223;223;223;48;2;226;226;226m▄▄▄▄▄▄\033[38;2;223;223;223;48;2;228;228;228m▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄\033[38;2;223;223;223;48;2;227;227;227m▄\033[38;2;223;223;223;48;2;226;226;226m▄\033[38;2;223;223;223;48;2;228;228;228m▄▄▄▄\033[38;2;223;223;223;48;2;227;227;227m▄\033[38;2;223;223;223;48;2;226;226;226m▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄\033[38;2;227;227;227;48;2;221;221;221m▄\033[m\n");
    printf("\033[48;2;228;228;228m        \033[38;2;228;228;228;48;2;227;227;227m▄\033[38;2;228;228;228;48;2;226;226;226m▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄\033[38;2;228;228;228;48;2;227;227;227m▄\033[48;2;228;228;228m \033[38;2;228;228;228;48;2;226;226;226m▄▄▄▄\033[38;2;228;228;228;48;2;227;227;227m▄\033[48;2;228;228;228m                \033[m\n");
    printf("\033[48;2;228;228;228m                                                \033[m\n");
    printf("\033[48;2;175;255;255m                   \033[38;2;175;255;255;48;2;197;244;244m▄\033[38;2;175;255;255;48;2;219;233;233m▄▄▄▄\033[38;2;175;255;255;48;2;212;236;236m▄\033[48;2;175;255;255m       \033[38;2;175;255;255;48;2;212;236;236m▄\033[38;2;175;255;255;48;2;219;233;233m▄▄▄▄▄▄▄▄▄▄▄▄\033[38;2;175;255;255;48;2;212;236;236m▄\033[48;2;175;255;255m  \033[m\n");
    printf("\033[48;2;175;255;255m                                                \033[m\n");
    printf("\033[48;2;175;255;255m                                                \033[m\n");
    printf("\033[48;2;175;255;255m                                                \033[m\n");
   // printf("\033[48;2;175;255;255m                                                \033[m\n");
   // printf("\033[48;2;175;255;255m                                                \033[m\n");
   // printf("\033[48;2;175;255;255m                                                \033[m\n");
   // printf("\033[48;2;175;255;255m                                                \033[m\n");
   // printf("\033[48;2;175;255;255m                                                \033[m\n");
   // printf("\033[48;2;175;255;255m                                                \033[m\n");
   // printf("\033[48;2;175;255;255m                                                \033[m\n");
   // printf("\033[48;2;175;255;255m                                                \033[m\n");
    printf("\033[48;2;175;255;255m                                                \033[m\n");

    printf("\033[38;2;135;228;0;48;2;142;255;43m▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄▄\033[m\n");
    printf("\033[48;2;135;95;0m  \033[38;2;135;95;0;48;2;163;123;66m▄\033[48;2;135;95;0m    \033[38;2;145;105;24;48;2;138;98;8m▄\033[38;2;138;98;8;48;2;136;96;3m▄\033[48;2;135;95;0m   \033[38;2;135;95;0;48;2;163;123;66m▄\033[48;2;135;95;0m       \033[38;2;135;95;0;48;2;163;123;66m▄\033[48;2;135;95;0m                \033[38;2;145;105;24;48;2;135;95;0m▄\033[38;2;138;98;8;48;2;135;95;0m▄\033[48;2;135;95;0m         \033[m\n");
  //  printf("\033[48;2;135;95;0m    \033[38;2;135;95;0;48;2;152;112;40m▄\033[38;2;135;95;0;48;2;141;101;13m▄\033[48;2;135;95;0m    \033[38;2;138;98;8;48;2;135;95;0m▄\033[38;2;136;96;3;48;2;135;95;0m▄\033[48;2;135;95;0m  \033[38;2;135;95;0;48;2;163;123;66m▄\033[48;2;135;95;0m \033[38;2;135;95;0;48;2;152;112;40m▄\033[38;2;135;95;0;48;2;141;101;13m▄\033[48;2;135;95;0m    \033[38;2;152;112;39;48;2;135;95;0m▄\033[38;2;141;101;13;48;2;135;95;0m▄\033[48;2;135;95;0m      \033[38;2;163;123;66;48;2;135;95;0m▄\033[48;2;135;95;0m      \033[38;2;135;95;0;48;2;138;98;8m▄\033[38;2;135;95;0;48;2;136;96;3m▄\033[48;2;135;95;0m    \033[38;2;152;112;39;48;2;135;95;0m▄\033[38;2;141;101;13;48;2;135;95;0m▄\033[48;2;135;95;0m   \033[m\n");
    //printf("\033[48;2;135;95;0m          \033[38;2;135;95;0;48;2;145;105;24m▄\033[38;2;135;95;0;48;2;138;98;8m▄\033[48;2;135;95;0m \033[38;2;138;98;8;48;2;145;105;24m▄\033[38;2;136;96;3;48;2;138;98;8m▄\033[48;2;135;95;0m                     \033[38;2;163;123;66;48;2;135;95;0m▄\033[48;2;135;95;0m           \033[m\n");
    printf("\n");
    */

    //printf("test image has been disabled to save space(4Kbytes)\n");

    printf("\x1b[0m");//remove formatting
    printf("\033[5i");//toggle aux port, so printers work, THIS IS FOR PDFS, UNLESS YOU DONT MIND WASTING PAPER OR INK
   // printf("print test\n");
   // printf("print test\n");
    printf("print test\n");
    //printf("print test\n");
    printf("\033[4i");//shutdown printer
    printf("\n");


}


/* void hexdumper(int start,int end){
	//char * flag=(char *)0xfff0; //point to a piece of ram
	int hexpointer = 0;//for the hex shower
	int asciipointer = 0;//for the ascii shower
	int current = start; //tracks adresses
	char *currentaddr = (char *)start;//handles addresses
	char valueviewer[2]; //used so it puts the value in here and terminates it with a 0x00
	for(current = start;current < end;current++){
	for(hexpointer = 0; hexpointer < 7; hexpointer++){
		printf("%x ",currentaddr);
		current++;
		currentaddr++;
	}
	for(asciipointer = 0; asciipointer < 7; asciipointer++){
		printf("%c ",currentaddr);
		current++;
		currentaddr++;
	}
	printf("\n");
	}
} */
/*
void hexdumper(int start,int end){
    //char * flag=(char *)0xfff0; //point to a piece of ram
    int hexpointer = 0;
    int asciipointer = 0;
    int current = start;
    char *currentaddr;
    while(current < end) {
        currentaddr = (char*)current;
        for(hexpointer = 0; hexpointer < 16; ++hexpointer){
          printf("%x ",*currentaddr);
          currentaddr++;
        }

        currentaddr = (char*)current;
        for(asciipointer = 0; asciipointer < 16; asciipointer++){
          if(*currentaddr >= 32 && *currentaddr <= 126) {
            printf("%c",*currentaddr);
          }
          else {
            printf(".");
          }
          currentaddr++;
        }

        current += 16;
        printf("\n");
    }
}*/

void infodisplay()
{
    char * flag=(char *)0xfff0;
    char buffer[12];
    printf("SBC1806 INFO\n");
    printf("if int flag is I then there has been an interrupt\n");
    printf("%c\n",flag);
    //memdisplay();
    printf("ROM: 128Kbytes Versão:8.2 18/10/2023\n");
    printf("RAM:128Kb/256Kb\n");


    //printf("\033[48;2;37;155;36m                                               \033[48;2;0;188;212m  \033[48;2;255;238;88m         \033[48;2;191;54;12m      \033[m\n");
    //printf("\033[48;2;37;155;36m                                               \033[48;2;0;188;212m  \033[48;2;255;238;88m         \033[48;2;191;54;12m      \033[m\n");
    //printf("\033[48;2;37;155;36m                                               \033[48;2;0;188;212m  \033[48;2;255;238;88m         \033[48;2;191;54;12m      \033[m\n");
    //printf("\033[48;2;37;155;36m                                               \033[48;2;0;188;212m  \033[48;2;255;238;88m         \033[48;2;191;54;12m      \033[m\n");
    //printf("\033[48;2;37;155;36m                                               \033[48;2;0;188;212m  \033[48;2;255;238;88m         \033[48;2;191;54;12m      \033[m\n");
    //printf("\033[48;2;37;155;36m                                               \033[48;2;0;188;212m  \033[48;2;255;238;88m         \033[48;2;191;54;12m      \033[m\n");
    //printf("\033[48;2;37;155;36m                                               \033[48;2;0;188;212m  \033[48;2;255;238;88m         \033[48;2;191;54;12m      \033[m\n");
    //printf("\033[48;2;37;155;36m                                               \033[48;2;0;188;212m  \033[48;2;255;238;88m         \033[48;2;191;54;12m      \033[m\n");
    printf("\n");
    printf("\033[48;2;37;155;36m User memory.\033[m\n");
    printf("Used: %dB/26kb\n",usermem);
	printf("\033[48;2;0;188;212m Program memory.\033[m\n");
	printf("Used %dB/16Kb\n",progmemorysize);
   // printf("\033[48;2;0;188;212m Heap and boundry memory.\033[m\n");
   // printf("Used:0B/128B\n");
   // printf("\033[48;2;255;238;88m Stack memory.\033[m\n");
   // printf("Used:64B/2kb\n");
   // printf("\033[48;2;191;54;12m BIOS memory.\033[m\n");
   // printf("Used:1B/4kb\n");
    printf("IO:\n");
    printf("	%d/4 GPIO 82C55\n",gpiocount);
    printf("	1/1 DUART SCC2692\n");
   // printf("	2/2 MAX232\n");
   // printf("	0/1 RTC CDP6818/BQ4845\n");
    printf("ADC IO:%d\n",ADCIO);
    printf("CPU:");
    printf("	CLOCK:5Mhz\n");
    printf("	Tipo:1806\n");
    printf("SCC2692\n");
    printf("	CLOCK:3.6864Mhz\n");
    printf("	Baund rate: 9600\n");
    printf("	Max character speed: 960(CPS)\n");
    //printf("PCB REV:4.0\n02/05/2023\n");
    //printf("Code size: 32Kbytes\n");
   // printf("Floating point number precision set by default: 3 decimal cases\n");
   // printf("Scientific notation if value above 1000 or below 0.001\n");
	
    //printf("Press Enter to continue.\n");
    //printf("%c",0x05); //there is an ENQ char here
    //gets(buffer);
    //printf("Terminal data:\n");
    //printf(buffer);
    printf("\n");

}

/*
void FileSysNameWrite(unsigned char FileID,char *name){
	
	//So you may notice on the top, we dont have the stack at 0xFFFF, everything from 0xEEEE to 0xFFFF is code reserved
	//we will save here the data
	
	//all files can only have up to 32 chars (32 + 1 for 0x00) 
	//524288bytes/16384bytes= 32 files
	//if each file was 32K then 16 files
	
	char *File = (char *)0xEEEF;//base address, this points to the first byte of file0
	//to read the first byte of file1 name, we do File[33+1]

	int i;
	unsigned int offset=33*FileID;
	
	for(i=0;i<32;i++){//since we could "overrun" it
		File[offset+i]=name[i];
	}
	File[offset+33]=0x00;//we add the 0x00 by hand
	
	
	//unsigned char write_data(unsigned long int address,unsigned char *data,unsigned int size)
	//32files * 33bytes = 1056 bytes to write
	FileSysSaveTable();
}*/
/*
unsigned char FileSysNameToAddress(char *name){
	
	char *File = (char *)0xEEEF;
	char fetchedbuffer[33];
	int i;
	//int j;
	for(i=0;i<32;i++){
		
		
		//read_data(0xFFFBDF,1056,fetchedbuffer);
		
		
		
		
		if(strcmp(name,File)==0){
			
			return i;
		}
	}
	
}
*/
//void FileSysIDToAddress(){}

//void FileSysList(){}

/*void FileSysSaveTable(){//save the file table from FileSysNameWrite
	char *File = (char *)0xEEEF;
	int i;
	//unsigned int offset=33*FileID;
	//0xFFFFFF-1056=0xFFFBDF
	write_data(0xFFFBDF,File,1056);
	
}

void FileSysFetchTable(){
	
	char *File = (char *)0xEEEF;
	read_data(0xFFFBDF,1056,File);
	
}

*/
void floatToScientific(float num)
{
    int exponent = 0;

    while (num >= 10.0 || num <= -10.0) {
        num /= 10.0;
        exponent++;
    }

    while (num < 1.0 && num > -1.0) {
        num *= 10.0;
        exponent--;
    }

    printf("%f x 10^", num);
    printf("%d", exponent);
}


/*
void print(char* string)
{
    while(*string) {
        putc(*string);
        string++;
    }
}

void printHex(unsigned int number, unsigned char digits)
{
    const char hexDigits[] = "0123456789ABCDEF";
    char output[20];
    char *output_pt = output;
    unsigned char flag = 0;

    if(digits) {
        flag = 1;
    }

    *output_pt = 0;
    output_pt++;

    do {
        *output_pt = hexDigits[number & 0x0F];
        number >>= 4;
        if(flag) {
            digits--;
        }
        output_pt++;
    } while((!flag && number) || (flag && digits));

    output_pt--;

    while(*output_pt) {
        putc(*output_pt);
        output_pt--;
    }
}
*/
void mem_view(unsigned int* startAddress, int length)
{
	
	printf("HEXVIEW OFF\n");
  /*  int i;
    int linecnt = 0;
    unsigned int *currentAddress, *endAddress;

    endAddress = startAddress + length;

    print("\nBase address: 0x");
    printHex((int)startAddress, 4);

    print("\n\nOffset  00 01 02 03 04 05 06 07 08 08 0A 0B 0C 0D 0E 0F  String\n");
    print("--------------------------------------------------------------------------\n");

    while(startAddress < endAddress) {
        printHex(linecnt, 4);
        print(":   ");

        currentAddress = startAddress;
        for(i = 0; i < 16; i++) {
            if(currentAddress < endAddress) {
                printHex(*currentAddress, 2);
            } else {
                print("  ");
            }
            putc(' ');
            currentAddress++;
        }
        putc(' ');

        currentAddress = startAddress;
        for(i = 0; i < 16; i++) {
            if(currentAddress < endAddress) {
                if(*currentAddress >= 32 && *currentAddress <= 126) {
                    putc(*currentAddress);
                } else {
                    putc('.');
                }
                currentAddress++;
            }
        }

        startAddress = currentAddress;
        linecnt += 16;
        putc('');
        putc('\n');
    }

    putc('');
    putc('\n');*/
}



/*
void SPIsend(char byte){//mainly for the MAX7219 as its MSB first LSB last

	char count = 0;

	while(count < 7){

		if(byte & 0x80){ //MOSI
			out(1,0x02);//portC
			out(2,0x01);//bit 0 on
			delay(10);
			out(2,0x03);//so bit 0 and 1 are on, we clock MOSI=1

		}else{
			out(1,0x02);//portC
			out(2,0x00);//bit 0 off
			delay(10);
			out(2,0x02);//so bit 1 is on but bit 0 is low, we clock MOSI=0
		}
		out(1,0x02);//portC
		delay(10);
		out(2,0x00);//turn them off
		byte = byte << 1;
		count++;

	}

}*/


//ALPHA
long double expression(char* string, char** lastPosition);

long double atofinternal(char *s, char** lastPosition)
#define isdigit(c) (c >= '0' && c <= '9')
{
    // This function stolen from either Rolf Neugebauer or Andrew Tolmach.
    // Probably Rolf.
    long double a = 0.0;
    int e = 0;
    int c;
    while ((c = *s++) != '\0' && isdigit(c))
    {
        a = a*10.0 + (c - '0');
    }
    if (c == '.')
    {
        while ((c = *s++) != '\0' && isdigit(c)) {
            a = a*10.0 + (c - '0');
            e = e-1;
        }
    }
    if (c == 'e' || c == 'E')
    {
        int sign = 1;
        int i = 0;
        c = *s++;
        if (c == '+') {
            c = *s++;
        } else if (c == '-') {
            c = *s++;
            sign = -1;
        }
        while (isdigit(c)) {
            i = i*10 + (c - '0');
            c = *s++;
        }
        e += i*sign;
    }
    while (e > 0)
    {
        a *= 10.0;
        e--;
    }
    while (e < 0)
    {
        a *= 0.1;
        e++;
    }

    *lastPosition = s - 1;
    return a;
}


long double factor(char* string, char** lastPosition)
{
    long double result;
    if(*string == '(') {
        string++;
        while(*string == ' ') {
            string++;    //skip spaces;
        }
        while(*string != ')' && *string != 0) {
            result = expression(string, &string);
        }
        string++;  // eat the )
    } else {
        result = atofinternal(string, &string);
    }

    *lastPosition = string;

    return result;
}


long double term(char* string, char** lastPosition)
{
    long double numResult = 0;
    long double result = 0;

    while(*string == ' ') {
        string++;    //skip spaces;
    }

    result = factor(string, &string);

    while(*string != 0) {


        while(*string == ' ') {
            string++;    //skip spaces;
        }

        if(*string == '*') { //if we see a * then do the multiplication.
            string++;
            while(*string == ' ') {
                string++;    //skip spaces;
            }
            result *= factor(string, &string);
        } else if(*string == '/') { //
            string++;
            while(*string == ' ') {
                string++;    //skip spaces;
				
            }

            result /= factor(string, &string);
        } else {
            break;
        }

    }
    *lastPosition = string;
    return result;
}


long double expression(char* string, char** lastPosition)
{
    long double numResult = 0;
    long double result = 0;

    while(*string == ' ') {
        string++;    //skip spaces;
    }

    result = term(string, &string);

    while(*string != 0) {


        while(*string == ' ') {
            string++;    //skip spaces;
        }

        if(*string == '+') { //if we see a * then do the multiplication.
            string++;
            while(*string == ' ') {
                string++;    //skip spaces;
            }
            result += term(string, &string);
        } else if(*string == '-') { //
            string++;
            while(*string == ' ') {
                string++;    //skip spaces;
            }
            result -= term(string, &string);
        } else {
            break;
        }

    }
    *lastPosition = string;
    return result;
}


void SPI_SEQUENCE_TRANSACTION(int bytesbetweenCS,char* string){
	
	//while(*string == ' ') {
     //   string++;    //skip spaces;
   // }
/*
    //result = term(string, &string);
	//char *bytesbetweenCS;
	char returnedbyte;
	int i;
	//char CSpolarity
	char *spibyte;
	char bytetosend[2];
	spibyte=strtok(string, ",");
	
	//bytesbetweenCS=spibyte;//get the number of bytes between each CS
	//if(bytesbetweenCS>0){
	while(spibyte){
		
		memcpy(bytetosend,spibyte,1);
		out(1,0x00);
		out(4,0x00);//CS goes low
		for(i=0;i<2;i++){
			
			printf("S:%x,",bytetosend);
			returnedbyte=spi_transfer2(atoi(bytetosend));
			printf("R:%x,",returnedbyte);
		}
		
		out(1,0x00);
		out(4,0x80);//CS goes high
		spibyte=strtok(string, ",");
	}
	printf("Done\n");
	//}else{
	//	printf("Error on ARG1, there has to be atleast 1 byte between each CS strobe!!\n");
	//}
	*/
}

void ADCPRINTVALUE(int channel,char relay){
	/*//long double  ADCERROR=(long double)0xf000;
	char hexvalue;
	long double voltage;
	int i;
	if(channel >= 0 && channel <= 7){
	out(1,0x01); //port b
	out(ADCIO,channel);//so select one of the lines
	out(1,0x02); //port c
			out(ADCIO,0x80);
			out(ADCIO,0x00);
			out(1,0x01); //port b
			for(i=0;i<300;i++){
				out(ADCIO,0x82);
				out(ADCIO,0x02);
			}
	out(1,0x00); //port a
	
	hexvalue = inp(ADCIO);
	voltage = hexvalue*0.01960784313;
	
	printf("Valor HEX: %x | Tensão: %f V\n",hexvalue,voltage-0.032);
	
	//if(channel == 7){
		//ADCERROR=-(long double)1.831-voltage;
		//printf("Calibração\nReferencia=1.831V\nLeitura=%f\nDiferença=%f\n",voltage,ADCERROR);
		//printf("%ld\n",ADCERROR);
		
	//}
	
		if(relay){
			printf("HEX enviado para LPT\n");
			out(1,0x00);
			out(4,hexvalue);
			
		}else{
			printf("Envio do valor HEX para LPT desligado\n");
		
		}
	
	}else{
		printf("Canal inválido 0-7\n");
	}*/
}
/*
void RTCPOKE(){//for cdp6818

	int seconds=0;
	int minutes=0;
	int hours=0;
	printf("time:\n");
	out(4,0x20);//set PB25 for Address set 0010 0000 -> 0x20
	out(7,0x00);//select address 0 for seconds register
	//out(4,0x10);//set PB24 for Data set, so we can read it 0001 0000 -> 0x10 //it only goes high when writing, low when we read
	seconds = inp(7);
	out(7,0x02);
	minutes = inp(7);
	out(7,0x04);
	hours = inp(7);
	
	printf("%d\n",seconds);
	printf("%d\n",minutes);
	printf("%d\n",hours);
	
	//printf("Acording to the RTC, its: %d:%d:%d\n",hours,minutes,seconds);
	//printf("HEX: %x:%x:%x\n",hours,minutes,seconds);
	
}
*/

void BIOSMENU(){
	//char ADCIO = (char)=0x0000;
	//char  baudrate=(char )0xfff5;
	
	/* char input;
	input = '0';
	BIOSMENULOOPLABEL:
	printf("\033[2J"); //clear screen
	printf("\033[0;0H");
	printf("EF1 = SCC_INT\n");
	switch(EF2func){
		
		case 1:
		printf("EF2 = User input\n");
		break;
		case 2:
		printf("EF2 = Baudrate select\n");
		break;
		case 3:
		printf("EF2 = OFF\n");
		break;
		default:
		printf("EF2 = N/A\n");
		//EF2func = 1;
	}
	
	switch(EF3func){
		
		case 1:
		printf("EF3 = User input\n");
		break;
		case 2:
		printf("EF3 = Baudrate select\n");
		break;
		case 3:
		printf("EF3 = OFF\n");
		break;
		default:
		printf("EF3 = N/A\n");
		//EF3func = 1;
	}
	
	switch(EF4func){
		
		case 1:
		printf("EF4 = User input\n");
		break;
		case 2:
		printf("EF4 = Baudrate select\n");
		break;
		case 3:
		printf("EF4 = SYSCALL\n");
		break;
		case 4:
		printf("EF4 = OFF\n");
		break;
		default:
		printf("EF4 = N/A\n");
		//EF4func = 1;
	}
	printf("ADC IO(5)\n");
	printf("IO:%d\n",ADCIO);
	
	/*printf("Baud Rate(6)\n");
	switch(baudrate){
		
		case 0xBB:
			printf("9600\n");
			break;
		
		default:
			printf("ERROR\n");
			baudrate=0xBB;
		
		
		
	}*/
	/*
	printf("Usa tecla 2 a 5 para mudar a função\n");
	printf("Usa c para fechar\n");
	
	while(input != 'c'){
		input = getc();
		printf("%c\n",input);
		switch(input){
			
			case '2':
			if(EF2func <= 3){
				EF2func++;
			}else{
				EF2func=1;
			}
			goto BIOSMENULOOPLABEL;
			break;
			case '3':
			if(EF3func <= 3){
				EF3func++;
			}else{
				EF3func=1;
			}
			goto BIOSMENULOOPLABEL;
			break;
			case '4':
			if(EF4func <= 4){
				EF4func++;
			}else{
				EF4func=1;
			}
			goto BIOSMENULOOPLABEL;
			break;
			case '5':
			if(ADCIO < 4){
				ADCIO++;
			}else{
				ADCIO=2;
			}
			goto BIOSMENULOOPLABEL;
			break;
			default:
			printf("nope\n");
			goto BIOSMENULOOPLABEL;
		}
		
		
		
	} */
	
}
	
/*
void tiff_image_printer(char * image){
	
	printf("Loading\n");
	printf("\033[1049h");//  	Enable alternative screen buffer, from xterm 
	printf("Alright\n");
	printf("\033[1049l");//  	Disable alternative screen buffer, from xterm 
	
}

*/
/*

// Provide the duration and period of buzzer signal in ms
void BUZZ(float duration, float period)
{
    long int i,cycles;
    float half_period;  // Initialize variables
 
    cycles=duration/period; // Compute the number of cycles to loop toggling the pin
    half_period = period/2; // Compute a half cycle period
 
    BUZZER_DDR = (1 << BUZZER_PIN) | BUZZER_DDR;  // Set the port for the buzzer output
 
    for (i=0;i<cycles;i++)   // Toggle the speaker the appropriate number of cycles
    {
        _delay_ms(half_period);                         // Wait a half cycle to toggle port pin
        BUZZER_PORT = (1 << BUZZER_PIN) | BUZZER_PORT;    // Set the port pin
        _delay_ms(half_period);                         // Wait a half cycle to clear the port pin
        BUZZER_PORT = ~(1 << BUZZER_PIN) & BUZZER_PORT;   // Clear the port pin
    }
 
    return;     // Return to the main program
}
 
void Alert(void)
{
    int i;
 
    for (i=0; i<4; i=i+1)
    {
        BUZZ(75,0.5);                   // Output a waveform of 75ms at 2KHz (period of 2KHz is 1/2000=0.5 ms)
        PORTA = 0b00000010 ^ PORTA;     // Toggle the LED pin by XOR (whenever a bit is XORed with 1, it is toggled)
        _delay_ms(75);                  // Wait for 75 ms
    }
    return;
}

*/

//int aLastState;


void setTime(unsigned char hour,unsigned char minutes,unsigned char seconds){
	
	
	
}


int rotaryencoder(int count){
	//int counter = 0; 
	//int aState;
	//int aLastState;  
	/*EF2func=pinA*/
	/*EF3func=pinB*/
	/*EF4func=SW, may only be used if userinput*/
	
	/*functions*/
	//char TEF1();
	//char TEF2();
	//char TEF3();
	//char TEF4();
	
	//if(EF2func != 1 || EF3func != 1){
	//	return 0; //signal error, as only in mode 1 its user input
	//}else{
		//if the BIOS settings allow for user input
		//if(TEF2()){count++;}
		//if(TEF3()){count--;}
		return count;
	//}
	
}



unsigned long int checksum(char *data,unsigned int size){
	unsigned int i;
	unsigned  long int checksum=0x00;
	
	for(i=0;i<size;i++){
		
		checksum+=data[i];
		
	}
	
	return checksum;
	
}

#define M_PI (double)3.1415

long double tan_graus(double angulo) {
  // Utilize a relação entre seno e cosseno para calcular a tangente
 long double seno = sin_graus(angulo);
 long double cosseno = cos_graus(angulo);

 long double resultado = seno / cosseno;
  printf("%ld\n",resultado);
  return resultado;
}

long double cos_graus(double angulo) {
  // Converta o ângulo para radianos
long double radianos = angulo * M_PI / 180.0;

  // Série de Taylor para o cosseno com 5 termos
long double resultado = 1.0 - (radianos * radianos) / 2.0 + (radianos * radianos * radianos * radianos) / 4.0;
  printf("%ld\n",resultado);
  return resultado;
}

long double sin_graus(double angulo) {
  // Converta o ângulo para radianos
  long double radianos = angulo * M_PI / 180.0;

  // Série de Taylor para o seno com 5 termos
  long double resultado = radianos - (radianos * radianos * radianos) / 3.0 + (radianos * radianos * radianos * radianos) / 5.0;
	printf("%ld\n",resultado);
  return resultado;
}

double raiz_quadrada(double n) {
  double x0 = n / 2.0;  // Estimativa inicial
  double x1 = x0;      // Valor inicial para iteração
  double epsilon = 0.01;  // Precisão desejada

  while ((x0 - x1) * (x0 - x1) > epsilon * n) {  // Critério de convergência
    x1 = x0;
    x0 = x1 - ((x1 * x1) - n) / (2 * x1);
  }
  printf("%ld\n",x0);
  return x0;
}


//char buffer[32];


void INT2(){//
	//#if(SCC == 2)
	/*while(getINTregister()==0x02){//so if bit 1 of ISR is set, it means RxRDY/ FFULL A
		TTYINPUT[TTYINPUTCOUNT]=sccIN();
		TTYINPUTCOUNT++;
	}
	if(getINTregister()!=0x02){printf("wrong interrupt\n");}
	
	//asm("	XIE\n");
	//asm("	CIE\n");
	#endif
	
	#if(SCC == 0)
		printf("wrong interrupt\n");
		//asm("	sex R0\n");
		//asm("	ret\n");
		//asm("	dis\n");
	#endif
	//TTYINPUTCOUNT++;
	//TTYINPUT[TTYINPUTCOUNT]=0x00;
	//asm("	lbr __INTS\n");
	//asm("	SEP R3\n");
	//asm("	lbr pastgets\n");
	asm("	lbr   intx\n");*/
}

void CSL2(){
	
	//out(1,0x01);
	//out(4,0x00);
}

void CSH2(){
	
	//out(1,0x00);
	//out(4,0x80);
}
/*
unsigned char write_data(unsigned long int address,unsigned char *data,unsigned int size){
	
	unsigned int i;
	unsigned int j;
	unsigned int count=0;
	
	CSL2();
	(void)spi_transfer2(0x06);//toggle writting
	CSH2();

	
	for(i=0;i<size;i++){//writes the data
		
		CSL2();
		(void)spi_transfer2(0x02); //page program
		//(void)spi_transfer2((unsigned char)((address >> 24) & 0xFF));
		//set address
		(void)spi_transfer2((unsigned char)((address >> 16) & 0xFF));
		(void)spi_transfer2((unsigned char)((address >> 8) & 0xFF));
		(void)spi_transfer2((unsigned char)(address & 0xFF));
		
		for(j=0;j<256&&j<size;j++){//we can write 256 bytes at a time and if size is less than 256, then only loop for "size" times
			
			(void)spi_transfer2(data[count]);
			count++;
		}
		CSH2();
		address+=256;
		
		
		
	}
	
	return 0;
	
	
}
*/

#define SPI_HANDLER(x) SPI_TRANSFER(x)

unsigned char write_data(unsigned long int address,unsigned char *data,unsigned int size){
	
	//NOTE: this erases 4Kbytes after the address, to only change a byte at an address, use change_data
    /*
    unsigned int i;
    unsigned int j;
    unsigned int count=0;
	unsigned char sector=address/4096; //so we get the sector
    
		

		CSL2();
		(void)SPI_HANDLER(0x06);//toggle writting
		CSH2();	
	
		CSL2();
		(void)SPI_HANDLER(0x20);//erase sector(4Kbytes)
		
		(void)SPI_HANDLER(0);
		(void)SPI_HANDLER(0);
		(void)SPI_HANDLER(sector);
		CSH2();
		
		CSL2();
		(void)SPI_HANDLER(0x06);//toggle writting
		CSH2();	

    while(count < size ) { //writes the data
        
        CSL2();
        (void)SPI_HANDLER(0x02); //page program
        //(void)SPI_HANDLER((unsigned char)((address >> 24) & 0xFF));
        //set address
        (void)SPI_HANDLER((unsigned char)((address >> 16) & 0xFF));
        (void)SPI_HANDLER((unsigned char)((address >> 8) & 0xFF));
        (void)SPI_HANDLER((unsigned char)(address & 0xFF));
        
        for(j=0;j<256 && count<size;j++) { //we can write 256 bytes at a time and if size is less than 256, then only loop for "size" times
            (void)SPI_HANDLER(data[count]);
            count++;
        }
        CSH2();
        address+=256;
    }  */

}

/*
unsigned char change_data(unsigned long int address,unsigned char *data,unsigned int size){
	
	
    
    unsigned int i;
    unsigned int j;
    unsigned int count=0;
    unsigned char holder[4096];
	
	//prior to this, read sector
	read_data(address,4096,holder);
	
    CSL2();
    (void)SPI_HANDLER(0x06);//toggle writting
    CSH2();

    while(count < size ) { //writes the data
        
        CSL2();
        (void)SPI_HANDLER(0x02); //page program
        //(void)SPI_HANDLER((unsigned char)((address >> 24) & 0xFF));
        //set address
        (void)SPI_HANDLER((unsigned char)((address >> 16) & 0xFF));
        (void)SPI_HANDLER((unsigned char)((address >> 8) & 0xFF));
        (void)SPI_HANDLER((unsigned char)(address & 0xFF));
        
        for(j=0;j<256 && count<size;j++) { //we can write 256 bytes at a time and if size is less than 256, then only loop for "size" times
            (void)SPI_HANDLER(data[count]);
            count++;
        }
        CSH2();
        address+=256;
    }  
}
*/

void mandelbrot(){//https://youtu.be/heSGogzIEUM?t=241
/*
	int k = 15;
	int i,j,r,x,y=-16;
	while(puts(""),y++<15)
		for(x=0;x++<84;putchar(" .:-;!/>)|&IH%*#"[k&15]))
			for(i=k=r=0;j=r*r-i*i-2+x/25,i=2*r*i+y/10,j*j+i*i<11&&k++<111;r=j);
	*/
	
	int k = 0;
    float i,j,r,x,y=-16;
    char chr[] = " .:-;!/>)|&IH%*#";
	char colors[] = {41,42,43,44,45,46,47,48,49};

    puts("\n");
    while(y < 15) {
        y++;
        x = 0;
        while(x < 84) {
            x++;

            i = 0;
            r = 0;
            k = 0;

            while(1) {
                j=r*r-i*i-2+x/25;
                i=2*r*i+y/10;

                if((j*j+i*i) < 11) {
                    if(!(k < 111)) {
                        k++;
                        break;
                    }
                    k++;
                }
                else {
                    break;
                }
                r = j;
            }

            //putchar(chr[k & 15]);
			  printf("\033[1;%dm ",colors[k&15]);
        }
        puts("\n");
		
    }
	/*
	int A,B,i;
    long double a,b,x,y,t,n=15;
    for(B=0;B<=4*n;B++){
        
        b=2-(B/n);
        for(A=0;A<=4*n;A++){
            
            a=-2+(A/n);
            x=0;
            y=0;
            for(i=1;i<=1000;i++){
                t=x;
                x=(x*x)-(y*y)+a;
                y=(2*t*y)+b;
                if((x*x)+(y*y)>4){
                    break;
                }
                
            }
            if(i==1001){
                printf(".");
            }else{
                printf(" ");
            }
            
            
        }
        
        printf("\n");

    }*/
}

	
	



void DS1302(){//kinda like SPI

	
	
	
	
	
}

unsigned char read_data(unsigned long int address,unsigned int count,char *databuffer){

}

void rtc_check(){
	
	char flags;
	out(1,0x01);
	out(4,0x0D);
	flags=inp(7);
	if(flags&&0x01){
		printf("RTC battery OK\n");
		
	}else{
		printf("RTC battery BAD\n");
	}
	printf("%x\n",flags);
}

void RTC_settime(int hour,int minute,int second){
	
	out(1,0x01);
	out(4,0x0E);
	out(7,0x0C);
	
	out(4,0x04);
	out(7,hour);
	
	out(4,0x02);
	out(7,minute);
	
	out(4,0x00);
	out(7,second);
	
	out(4,0x0E);
	out(7,0x04);
	
}

void INT() 	//interrupt routine just sets a flag to show interrupt has happened
{/*
    //allows us to check for the scc
    //we could use C code i think
    asm("	align 64\n"
        "INTX: SEX  2\n"
        "	;CID ;disables interrupts from counter for now, enable outside\n"
        "	;XID ;shutdown external interrupts\n"
        "	;STPC ;stop counter \n"
        "	LDA  2         ; recover carry\n"
        "	SHL\n"
        "	LDA  2         ; recover A\n"
        "	RET             ; < exit\n"
		
		
		
		
        "__INTS: NOP             ; > entry\n"
        "	DEC  2\n"
        "	SAV             ; save T\n"
        "	DEC  2\n"
        "	STXD           	; save A\n"
        "	SHRC            ; move carry to D \n"
        "	STR  2			; save carry\n"

        "	pushr R15\n"
        "	ldaD R15,0xfff0\n ; point to the flag\n"
        "	ldi	73\n        ;ascii I for interrupt\n"
        "	str R15\n"

        "	popr R15\n"
		//"	lbr _INT2\n"
        "	br   intx\n"
       );
*/
}

void sleepMODE(char timed,char mode){
	//,char preset removed
	//IDLES THE CPU
	while(1){
		asm(	        "	CIE ;enable interrupts from counter for now, enable outside\n"
						"	XIE ;enable external interrupts\n"
						"	REQ ;turn off Q\n");
		if(timed){
			//we set timer
			
			//asm("");
			
			switch(mode){
				
				case 0:
					asm("	STM\n"); //set timer mode and start
					break;
				case 1:
					asm("	SCM1\n");//set counter mode 1 and start
					break;
				case 2:
					asm("	SCM2\n");//set counter mode 2 and start
					break;
				case 3:
					asm("	SPM1\n");//set pulse width mode 1 and start
					break;
				case 4:
					asm("	SPM2\n");//set pulse width mode 2 and start
					break;
				case 5:
					break;
				
			}
			
			
		}
			
		asm("	ldAD R1,_INTHANDLER  ;.. R1 = INTERRUPT PC\n");//get the interrupt vector ready
		asm("	IDL\n");//pause cpu
		//-----//
		//-----//
		asm("	nop\n");
		asm("	nop\n");
		asm("	br _exitsleep\n");
		
		//asm("	B4 _exitsleep\n");//if B4 gets pulled low then we exit sleep mode else we loop, this is because of the watchdog of the RTC	
		
		
	}
	asm("_exitsleep:\n");
	asm("	SEQ ;turn on Q\n");
	       // "	CID ;disables interrupts from counter for now, enable outside\n"
			//"	XID ;shutdown external interrupts\n"
	//exit label, allows the sleep mode to be exited
	printf("<info>::Left sleep mode (interrupt was called)\n");
}




void INT_HANDLER(){
	asm("_INTHANDLER: \n");
	asm("	SAV\n");
/* 	asm("	align 64\n"
		"_INTHANDLER: \n"
		"    CID ;disables interrupts from counter for now, enable outside\n"
        "    XID ;shutdown external interrupts\n"
		
		"	 SEX R2\n"
		"	 DEC R2\n"
	//	"	 LDI 23h\n" //X=>R2 //P=>R3
	//	"	 STXD\n"
		//"	 INC R2\n"
		//"	 MARK\n"
		"    SAV\n"
		"    NOP\n"
		"	 XIE\n"
		"	 CIE\n"
		"    RET\n"//i should use RET but so far it only fetches the correct X reg, P stays at 8 for some reason
		"	 BR _INTHANDLER\n"
		//"	 SEP R3\n"
	//	"	SEX R2\n"
	//	"	SAV ;save stuff ;should replace with 1806 DSAV\n"
	//	"	NOP\n"
	//	"	NOP\n"
	//	"	RET ;return and leave the interrupt\n"
	//	"	br _INTHANDLER\n"
	); */
	
	asm("	RET\n");
	asm("	BR _INTHANDLER\n");
	//putc('>');
	
	
	
	
	
}
//use -tpt to debug traces (ADDS ALOT OF OVERHEAD)
/*
void ptd(){
asm("_pt: sex 12\n" //trace print routine.
"$$n: ldn 12\n"
" out 7\n"
" lbnz $$n\n"
" sex 2\n"
" cretn\n");
}*/

#include <olduino.c>
#include <stdlib.c>
//#include <dynamic.c>
#if(SCC == 1)
#include <sccAPI.c>
#endif

#if(SCC == 0)
void includeser2()
{
    asm("BAUDRATE EQU 	9600\n");
    asm(" include xrwjrT3.inc\n");
    asm(" include serwjrT3.inc\n");
}
#endif


